



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《JAVA与模式》之工厂方法模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《JAVA与模式》之工厂方法模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 21:49:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　在阎宏博士的《JAVA与模式》一书中开头是这样描述工厂方法模式的：</p>
<p><strong>　　工厂方法模式是类的创建模式，又叫做虚拟构造子(Virtual Constructor)模式或者多态性工厂（Polymorphic Factory）模式。</strong></p>
<p><strong>　　工厂方法模式的用意是定义一个创建产品对象的工厂接口，将实际创建工作推迟到子类中。</strong></p>
<p>那么<strong>工厂方法模式</strong>是在什么场景下使用呢，下面就以本人的理解举例说明:</p>
<p>　　相信很多人都做过导入导出功能，就拿导出功能来说。有这么一个需求：XX系统需要支持对数据库中的员工薪资进行导出，并且支持多种格式如：HTML、CSV、PDF等，每种格式导出的结构有所不同，比如：财务跟其他人对导出薪资的HTML格式要求可能会不一样，因为财务可能需要特定的格式方便核算或其他用途。</p>
<p>　　如果使用简单工厂模式，则工厂类必定过于臃肿。因为简单工厂模式只有一个工厂类，它需要处理所有的创建的逻辑。假如以上需求暂时只支持3种导出的格式以及2种导出的结构，那工厂类则需要6个if else来创建6种不同的类型。如果日后需求不断增加，则后果不堪设想。</p>
<p>　　这时候就需要工厂方法模式来处理以上需求。在工厂方法模式中，核心的工厂类不再负责所有的对象的创建，而是将具体创建的工作交给子类去做。这个核心类则摇身一变，成为了一个抽象工厂角色，仅负责给出具体工厂子类必须实现的接口，而不接触哪一个类应当被实例化这种细节。</p>
<p>　　这种进一步抽象化的结果，使这种工厂方法模式可以用来允许系统在不修改具体工厂角色的情况下引进新的产品，这一特点无疑使得工厂方法模式具有超过简单工厂模式的优越性。下面就针对以上需求设计UML图：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/629250/201903/629250-20190315174304161-1219762583.png" /></p>
<p>　　从上图可以看出，这个使用的工厂方法模式的系统涉及到以下角色：</p>
<p>　　<strong>抽象工厂（ExportFactory）角色</strong>：担任这个角色的是工厂方法模式的核心，任何在模式中创建对象的工厂类必须实现这个接口。在实际的系统中，这个角色也常常使用抽象类实现。</p>
<p>　　<strong>具体工厂（ExportHtmlFactory、ExportPdfFactory）角色</strong>：担任这个角色的是实现了抽象工厂接口的具体JAVA类。具体工厂角色含有与业务密切相关的逻辑，并且受到使用者的调用以创建导出类（如：ExportStandardHtmlFile）。</p>
<p>　　<strong>抽象导出（ExportFile）角色</strong>：工厂方法模式所创建的对象的超类，也就是所有导出类的共同父类或共同拥有的接口。在实际的系统中，这个角色也常常使用抽象类实现。</p>
<p>　　<strong>具体导出（ExportStandardHtmlFile等）角色</strong>：这个角色实现了抽象导出（ExportFile）角色所声明的接口，工厂方法模式所创建的每一个对象都是某个具体导出角色的实例。</p>
<h1>源代码</h1>
<p>　　首先是抽象工厂角色源代码。它声明了一个工厂方法，要求所有的具体工厂角色都实现这个工厂方法。参数type表示导出的格式是哪一种结构，如：导出HTML格式有两种结构，一种是标准结构，一种是财务需要的结构。</p>
<div>
<pre class="prettyprint linenums">public interface ExportFactory {<br />    public ExportFile factory(String type);<br />}</pre>
</div>
<p>　　具体工厂角色类源代码：</p>
<div>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class ExportHtmlFactory implements ExportFactory{

    @Override<br />    public ExportFile factory(String type) {<br />        // TODO Auto-generated method stub<br />        if("standard".equals(type)){

            return new ExportStandardHtmlFile();

        }else if("financial".equals(type)){

            return new ExportFinancialHtmlFile();

        }else{<br />            throw new RuntimeException("没有找到对象");<br />        }<br />    }

}</pre>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class ExportPdfFactory implements ExportFactory {

    @Override<br />    public ExportFile factory(String type) {<br />        // TODO Auto-generated method stub<br />        if("standard".equals(type)){

            return new ExportStandardPdfFile();

        }else if("financial".equals(type)){

            return new ExportFinancialPdfFile();

        }else{<br />            throw new RuntimeException("没有找到对象");<br />        }<br />    }

}</pre>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>　　抽象导出角色类源代码：</p>
<div>
<pre class="prettyprint linenums">public interface ExportFile {<br />    public boolean export(String data);<br />}</pre>
</div>
<p>　　具体导出角色类源代码，通常情况下这个类会有复杂的业务逻辑。</p>
<div>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class ExportFinancialHtmlFile implements ExportFile{

    @Override<br />    public boolean export(String data) {<br />        // TODO Auto-generated method stub<br />        /**<br />         * 业务逻辑<br />         */<br />        System.out.println("导出财务版HTML文件");<br />        return true;<br />    }

}</pre>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class ExportFinancialPdfFile implements ExportFile{

    @Override<br />    public boolean export(String data) {<br />        // TODO Auto-generated method stub<br />        /**<br />         * 业务逻辑<br />         */<br />        System.out.println("导出财务版PDF文件");<br />        return true;<br />    }

}</pre>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class ExportStandardHtmlFile implements ExportFile{

    @Override<br />    public boolean export(String data) {<br />        // TODO Auto-generated method stub<br />        /**<br />         * 业务逻辑<br />         */<br />        System.out.println("导出标准HTML文件");<br />        return true;<br />    }

}</pre>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
</div>
<div>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class ExportStandardPdfFile implements ExportFile {

    @Override<br />    public boolean export(String data) {<br />        // TODO Auto-generated method stub<br />        /**<br />         * 业务逻辑<br />         */<br />        System.out.println("导出标准PDF文件");<br />        return true;<br />    }

}</pre>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>客户端角色类源代码：</p>
<div>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class Test {

    /**<br />     * @param args<br />     */<br />    public static void main(String[] args) {<br />        // TODO Auto-generated method stub<br />        String data = "";<br />        ExportFactory exportFactory = new ExportHtmlFactory();<br />        ExportFile ef = exportFactory.factory("financial");<br />        ef.export(data);<br />    }

}</pre>
<div><img referrerpolicy="no-referrer"src="//common.cnblogs.com/images/copycode.gif" /></div>
</div>
<h1>工厂方法模式的活动序列图</h1>
<h1><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/629250/201903/629250-20190315174317584-843489853.png" /></h1>
<p>　　客户端创建ExportHtmlFactory对象，这时客户端所持有变量的静态类型为ExportFactory，而实际类型为ExportHtmlFactory。然后客户端调用ExportHtmlFactory对象的工厂方法factory()，接着后者调用ExportFinancialHtmlFile的构造子创建出导出对象。</p>
<h1>工厂方法模式和简单工厂模式</h1>
<p>　　工厂方法模式和简单工厂模式在结构上的不同很明显。工厂方法模式的核心是一个抽象工厂类，而简单工厂模式把核心放在一个具体类上。<br />　　工厂方法模式退化后可以变得很像简单工厂模式。设想如果非常确定一个系统只需要一个具体工厂类，那么不妨把抽象工厂类合并到具体工厂类中去。由于只有一个具体工厂类，所以不妨将工厂方法改为静态方法，这时候就得到了简单工厂模式。</p>
<p>　　如果系统需要加入一个新的导出类型，那么所需要的就是向系统中加入一个这个导出类以及所对应的工厂类。没有必要修改客户端，也没有必要修改抽象工厂角色或者其他已有的具体工厂角色。对于增加新的导出类型而言，这个系统完全支持&ldquo;开-闭原则&rdquo;。<br />　　</p>
<h1>完结</h1>
<p>　　一个应用系统是由多人开发的，导出的功能是你实现的，但是使用者（调用这个方法的人）可能却是其他人。这时候你应该设计的足够灵活并尽可能降低两者之间的耦合度，当你修改或增加一个新的功能时，使用者不需要修改任何地方。假如你的设计不够灵活，那么将无法面对客户多变的需求。可能一个极小的需求变更，都会使你的代码结构发生改变，并导致其他使用你所提供的接口的人都要修改他们的代码。牵一处而动全身，这就使得日后这个系统将难以维护。</p>
<p>via：<a href="http://www.cnblogs.com/java-my-life/archive/2012/03/25/2416227.html" rel="external nofollow noreferrer">http://www.cnblogs.com/java-my-life/archive/2012/03/25/2416227.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gy0e97.html">AFNetworking 3&period;0 源码解读（一）之 AFNetworkReachabilityManager</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zr7mdq.html">tomcat8 配置在线管理应用功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96d1o38.html">&lbrack;z&rsqb;Oracle性能优化-读懂执行计划</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyxyj28.html">&lbrack;oracle&rsqb; 解决ORA-30036：无法按8扩展段（在还原表空间&OpenCurlyQuote;XXXX&rsquo;中）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8klg6rq.html">Java使用for循环打印乘法口诀（正倒左右三角形）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql36xkq.html">Linux下编译安装PCRE库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmewjx9.html">160928、JQuery解析XML数据的demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmxg409.html">IE&comma; FF&comma; Safari前端开发常用调试工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydlmg2q.html">Using Nini &period;NET Configuration Library</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k17rej9.html">php 多维数组如何用foreach遍历修改其中的一个值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kr6y49.html">Linux环境进程间通信&lpar;三&rpar;：消息队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvxyxq.html">【&period;Net Framework 体积大？】不安装&period;net framework 也能运行！？原理补充-3</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k7op09.html">Linux 开启和关闭 Ping 操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzkdw08.html">金融量化分析【day112】&colon;股票数据分析Tushare2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw66rk8.html">对linux安装中文字体库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vmm40q.html">页面中 js&comma;css 集中提取</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emewom9.html">EF（EF Core）中的NotMappedAttribute（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vm3lzq.html">java入门--4111&colon;判断游戏胜者-Who Is the Winner</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2o6ez8.html">根据wsdl，apache cxf的wsdl2java工具生成客户端、服务端代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kmzmvq.html">python unicode</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwjg6lk8.html">Flutter 即学即用系列博客&mdash;&mdash;10 混淆</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyvekz9.html">PyQtdeploy-V2&period;4 User Guide 中文 （二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z0ye39.html">【设计模式】抽象工厂模式 Abstract Factory Pattern</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1k15dq.html">python xlrd 读取excel&period;md</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdrdrd9.html">七、Android动画</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp2w5xq.html">PM过程能力成熟度4级</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdrw1d9.html">MongoDB中数组类型相关的操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me0jx0q.html">【视频】设计模式&lpar;C&plus;&plus;&rpar;视频讲解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz3ex48.html">maven生成项目慢解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkvlvv8.html">win7下怎么安装IIS</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
